
Redmine - Patch #6985

Bug in diff partial

2010-11-26 10:38 - Ivan Evtuhovich

Status: Closed Start date: 2010-11-26

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: SCM Estimated time: 0.00 hour

Target version:    

Description

When using redmine_diff_email plugin, it throws error when generated diff is big

Patch attached

I18n::ArgumentError in Repositories#show

Showing app/views/common/_diff.rhtml where line #67 raised:

Object must be a Date, DateTime or Time object. :text_diff_truncated given.

Extracted source (around line #67):

64: </div>

65: <% end -%>

66: 

67: <%= l(:text_diff_truncated) if diff.truncated? %>

Trace of template inclusion: vendor/plugins/redmine_diff_email/app/views/diff_mailer/diff_notifica

tion.text.html.rhtml

History

#1 - 2010-11-26 10:44 - Felix Schäfer

Is this a bug in core redmine or in the plugin? If the latter is the case, this is the wrong place to report this.

#2 - 2010-11-26 12:37 - Ivan Evtuhovich

This is problem in redmine.

l(:text_diff_truncated) - but l() should receive Date, DateTime or Time, not Symbol. I just change l() to t()

#3 - 2010-11-26 13:52 - Felix Schäfer

Ivan Evtuhovich wrote:

This is problem in redmine.

l(:text_diff_truncated) - but l() should receive Date, DateTime or Time, not Symbol. I just change l() to t()

 Nope, redmine extends I18n to make l also accept strings, see source:/trunk/lib/redmine/i18n.rb#L7, so that's not the problem. It also runs fine in the

console:

>> include Redmine::I18n

=> Object

>> l(:text_diff_truncated)

=> "... This diff was truncated because it exceeds the maximum size that can be displayed."

#4 - 2010-11-26 13:57 - Ivan Evtuhovich

Thanx, i'll try to investigate a bit more

#5 - 2010-11-26 15:17 - Ivan Evtuhovich

I insert this code:

<%
https://www.redmine.org/projects/redmine/repository/svn/entry/trunk/lib/redmine/i18n.rb#L7


    p "*" * 100

    p method(:l)

%>

<%= l(:text_diff_truncated) if diff.truncated? %>

 and get in server output

#<Method: ActionView::Base(ActionView::Helpers::TranslationHelper)#l>   

And it use i18n-0.4.2 localize

  /home/brun/.rvm/gems/ruby-1.8.7-p302@ruby-1.8.7-p249/gems/i18n-0.4.2/lib/i18n/backend/base.rb:54:in `localiz

e'

    /home/brun/.rvm/gems/ruby-1.8.7-p302@ruby-1.8.7-p249/gems/i18n-0.4.2/lib/i18n.rb:240:in `localize'

    app/views/common/_diff.rhtml:71:in `_run_rhtml_app47views47common47_diff46rhtml_locals_diff_diff_type_obje

ct'

 I have no idea what to do

#6 - 2010-11-27 12:23 - Jean-Philippe Lang

- Status changed from New to Closed

This is a plugin problem. It should either include Redmine::I18n in its mailer (so that #l accepts a Symbol like in the core views) or use the ::I18n

syntax.

You may want to submit your patch to the plugin author.
